/*
polyprint.v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package polyprintapi

import (
	"encoding/json"
)

// checks if the NfcReorderRequestAddress type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NfcReorderRequestAddress{}

// NfcReorderRequestAddress struct for NfcReorderRequestAddress
type NfcReorderRequestAddress struct {
	CompanyName interface{} `json:"company_name,omitempty"`
	// example: Johny Bobby
	Recipient interface{} `json:"recipient,omitempty"`
	StreetWithHouseNumber interface{} `json:"street_with_house_number,omitempty"`
	Zip interface{} `json:"zip,omitempty"`
	City interface{} `json:"city,omitempty"`
}

// NewNfcReorderRequestAddress instantiates a new NfcReorderRequestAddress object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNfcReorderRequestAddress() *NfcReorderRequestAddress {
	this := NfcReorderRequestAddress{}
	return &this
}

// NewNfcReorderRequestAddressWithDefaults instantiates a new NfcReorderRequestAddress object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNfcReorderRequestAddressWithDefaults() *NfcReorderRequestAddress {
	this := NfcReorderRequestAddress{}
	return &this
}

// GetCompanyName returns the CompanyName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcReorderRequestAddress) GetCompanyName() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.CompanyName
}

// GetCompanyNameOk returns a tuple with the CompanyName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcReorderRequestAddress) GetCompanyNameOk() (*interface{}, bool) {
	if o == nil || IsNil(o.CompanyName) {
		return nil, false
	}
	return &o.CompanyName, true
}

// HasCompanyName returns a boolean if a field has been set.
func (o *NfcReorderRequestAddress) HasCompanyName() bool {
	if o != nil && IsNil(o.CompanyName) {
		return true
	}

	return false
}

// SetCompanyName gets a reference to the given interface{} and assigns it to the CompanyName field.
func (o *NfcReorderRequestAddress) SetCompanyName(v interface{}) {
	o.CompanyName = v
}

// GetRecipient returns the Recipient field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcReorderRequestAddress) GetRecipient() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Recipient
}

// GetRecipientOk returns a tuple with the Recipient field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcReorderRequestAddress) GetRecipientOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Recipient) {
		return nil, false
	}
	return &o.Recipient, true
}

// HasRecipient returns a boolean if a field has been set.
func (o *NfcReorderRequestAddress) HasRecipient() bool {
	if o != nil && IsNil(o.Recipient) {
		return true
	}

	return false
}

// SetRecipient gets a reference to the given interface{} and assigns it to the Recipient field.
func (o *NfcReorderRequestAddress) SetRecipient(v interface{}) {
	o.Recipient = v
}

// GetStreetWithHouseNumber returns the StreetWithHouseNumber field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcReorderRequestAddress) GetStreetWithHouseNumber() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.StreetWithHouseNumber
}

// GetStreetWithHouseNumberOk returns a tuple with the StreetWithHouseNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcReorderRequestAddress) GetStreetWithHouseNumberOk() (*interface{}, bool) {
	if o == nil || IsNil(o.StreetWithHouseNumber) {
		return nil, false
	}
	return &o.StreetWithHouseNumber, true
}

// HasStreetWithHouseNumber returns a boolean if a field has been set.
func (o *NfcReorderRequestAddress) HasStreetWithHouseNumber() bool {
	if o != nil && IsNil(o.StreetWithHouseNumber) {
		return true
	}

	return false
}

// SetStreetWithHouseNumber gets a reference to the given interface{} and assigns it to the StreetWithHouseNumber field.
func (o *NfcReorderRequestAddress) SetStreetWithHouseNumber(v interface{}) {
	o.StreetWithHouseNumber = v
}

// GetZip returns the Zip field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcReorderRequestAddress) GetZip() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Zip
}

// GetZipOk returns a tuple with the Zip field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcReorderRequestAddress) GetZipOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Zip) {
		return nil, false
	}
	return &o.Zip, true
}

// HasZip returns a boolean if a field has been set.
func (o *NfcReorderRequestAddress) HasZip() bool {
	if o != nil && IsNil(o.Zip) {
		return true
	}

	return false
}

// SetZip gets a reference to the given interface{} and assigns it to the Zip field.
func (o *NfcReorderRequestAddress) SetZip(v interface{}) {
	o.Zip = v
}

// GetCity returns the City field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *NfcReorderRequestAddress) GetCity() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.City
}

// GetCityOk returns a tuple with the City field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *NfcReorderRequestAddress) GetCityOk() (*interface{}, bool) {
	if o == nil || IsNil(o.City) {
		return nil, false
	}
	return &o.City, true
}

// HasCity returns a boolean if a field has been set.
func (o *NfcReorderRequestAddress) HasCity() bool {
	if o != nil && IsNil(o.City) {
		return true
	}

	return false
}

// SetCity gets a reference to the given interface{} and assigns it to the City field.
func (o *NfcReorderRequestAddress) SetCity(v interface{}) {
	o.City = v
}

func (o NfcReorderRequestAddress) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NfcReorderRequestAddress) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.CompanyName != nil {
		toSerialize["company_name"] = o.CompanyName
	}
	if o.Recipient != nil {
		toSerialize["recipient"] = o.Recipient
	}
	if o.StreetWithHouseNumber != nil {
		toSerialize["street_with_house_number"] = o.StreetWithHouseNumber
	}
	if o.Zip != nil {
		toSerialize["zip"] = o.Zip
	}
	if o.City != nil {
		toSerialize["city"] = o.City
	}
	return toSerialize, nil
}

type NullableNfcReorderRequestAddress struct {
	value *NfcReorderRequestAddress
	isSet bool
}

func (v NullableNfcReorderRequestAddress) Get() *NfcReorderRequestAddress {
	return v.value
}

func (v *NullableNfcReorderRequestAddress) Set(val *NfcReorderRequestAddress) {
	v.value = val
	v.isSet = true
}

func (v NullableNfcReorderRequestAddress) IsSet() bool {
	return v.isSet
}

func (v *NullableNfcReorderRequestAddress) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNfcReorderRequestAddress(val *NfcReorderRequestAddress) *NullableNfcReorderRequestAddress {
	return &NullableNfcReorderRequestAddress{value: val, isSet: true}
}

func (v NullableNfcReorderRequestAddress) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNfcReorderRequestAddress) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


